Index: CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/styles/plugin.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -141,35 +141,4 @@
 		},
 
-		// Removes any conflicting styles from within the specified range..
-		removeConflictsFromRange : function ( range )
-		{
-			var style = this,
-					overrides = getOverrides( style ),
-					styleCandidates = [],
-					overrideCandidates = [];
-
-			var walker = new CKEDITOR.dom.walker( range );
-			walker.evaluator = function( node )
-			{
-				if ( node.type == CKEDITOR.NODE_ELEMENT )
-				{
-					if ( node.is( style.element ) )
-						styleCandidates.push( node );
-					if ( node.getName() in overrides )
-						overrideCandidates.push( node );
-				}
-			};
-			walker.lastForward();
-
-			// First remove from element any style conflictions.
-			for ( var i = styleCandidates.length - 1 ; i >= 0 ; i-- )
-				removeFromElement( style,  styleCandidates[ i ] );
-
-			// Now remove any other element with different name that is
-			// defined to be overriden.
-			for ( i = overrideCandidates.length - 1 ; i >= 0 ; i-- )
-				removeOverrides( overrideCandidates[ i ], overrides[ overrideCandidates[ i ].getName() ] ) ;
-		},
-
 		applyToObject : function( element )
 		{
@@ -218,9 +187,11 @@
 				case CKEDITOR.STYLE_INLINE :
 				case CKEDITOR.STYLE_BLOCK :
-					return true;
+					break;
 
 				case CKEDITOR.STYLE_OBJECT :
 					return elementPath.lastElement.getAscendant( this.element, true );
 			}
+
+			return true;
 		},
 
@@ -299,4 +270,37 @@
 			}
 			return false;
+		},
+
+		// Builds the preview HTML based on the styles definition.
+		buildPreview : function()
+		{
+			var styleDefinition = this._.definition,
+				html = [],
+				elementName = styleDefinition.element;
+
+			// Avoid <bdo> in the preview.
+			if ( elementName == 'bdo' )
+				elementName = 'span';
+
+			html = [ '<', elementName ];
+
+			// Assign all defined attributes.
+			var attribs	= styleDefinition.attributes;
+			if ( attribs )
+			{
+				for ( var att in attribs )
+				{
+					html.push( ' ', att, '="', attribs[ att ], '"' );
+				}
+			}
+
+			// Assign the style attribute.
+			var cssStyle = CKEDITOR.style.getStyleText( styleDefinition );
+			if ( cssStyle )
+				html.push( ' style="', cssStyle, '"' );
+
+			html.push( '>', styleDefinition.name, '</', elementName, '>' );
+
+			return html.join( '' );
 		}
 	};
@@ -373,10 +377,4 @@
 		range.enlarge( CKEDITOR.ENLARGE_ELEMENT );
 		range.trim();
-
-		// Remove all style conflictions within the range,
-		// e.g. style="color:red" is conflicting with style="color:blue".
-		var enlargedBookmark = range.createBookmark();
-		this.removeConflictsFromRange( range );
-		range.moveToBookmark( enlargedBookmark );
 
 		// Get the first node to be processed and the last, which concludes the
@@ -543,4 +541,8 @@
 					// Move the contents of the range to the style element.
 					styleRange.extractContents().appendTo( styleNode );
+
+					// Here we do some cleanup, removing all duplicated
+					// elements from the style element.
+					removeFromInsideElement( this, styleNode );
 
 					// Insert it into the range position (it is collapsed after
@@ -970,4 +972,34 @@
 
 		removeEmpty && removeNoAttribsElement( element );
+	}
+
+	// Removes a style from inside an element.
+	function removeFromInsideElement( style, element )
+	{
+		var def = style._.definition,
+			attribs = def.attributes,
+			styles = def.styles,
+			overrides = getOverrides( style );
+
+		var innerElements = element.getElementsByTag( style.element );
+
+		for ( var i = innerElements.count(); --i >= 0 ; )
+			removeFromElement( style,  innerElements.getItem( i ) );
+
+		// Now remove any other element with different name that is
+		// defined to be overriden.
+		for ( var overrideElement in overrides )
+		{
+			if ( overrideElement != style.element )
+			{
+				innerElements = element.getElementsByTag( overrideElement ) ;
+				for ( i = innerElements.count() - 1 ; i >= 0 ; i-- )
+				{
+					var innerElement = innerElements.getItem( i );
+					removeOverrides( innerElement, overrides[ overrideElement ] ) ;
+				}
+			}
+		}
+
 	}
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/styles/styles/default.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/styles/styles/default.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/styles/styles/default.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/stylescombo/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/stylescombo/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/stylescombo/plugin.js	(revision 5388)
@@ -86,5 +86,5 @@
 									combo.add(
 										styleName,
-										style.type == CKEDITOR.STYLE_OBJECT ? styleName : buildPreview( style._.definition ),
+										style.type == CKEDITOR.STYLE_OBJECT ? styleName : style.buildPreview(),
 										styleName );
 								}
@@ -149,5 +149,5 @@
 					onOpen : function()
 					{
-						if ( CKEDITOR.env.ie )
+						if ( CKEDITOR.env.ie || CKEDITOR.env.webkit )
 							editor.focus();
 
@@ -191,36 +191,4 @@
 	});
 
-	function buildPreview( styleDefinition )
-	{
-		var html = [];
-
-		var elementName = styleDefinition.element;
-
-		// Avoid <bdo> in the preview.
-		if ( elementName == 'bdo' )
-			elementName = 'span';
-
-		html = [ '<', elementName ];
-
-		// Assign all defined attributes.
-		var attribs	= styleDefinition.attributes;
-		if ( attribs )
-		{
-			for ( var att in attribs )
-			{
-				html.push( ' ', att, '="', attribs[ att ], '"' );
-			}
-		}
-
-		// Assign the style attribute.
-		var cssStyle = CKEDITOR.style.getStyleText( styleDefinition );
-		if ( cssStyle )
-			html.push( ' style="', cssStyle, '"' );
-
-		html.push( '>', styleDefinition.name, '</', elementName, '>' );
-
-		return html.join( '' );
-	}
-
 	function sortStyles( styleA, styleB )
 	{
Index: CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/dialogs/tableCell.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5388)
@@ -516,7 +516,12 @@
 			onOk : function()
 			{
+				var selection = this._.editor.getSelection(),
+					bookmarks = selection.createBookmarks();
+
 				var cells = this.cells;
 				for ( var i = 0 ; i < cells.length ; i++ )
 					this.commitContent( cells[ i ] );
+
+				selection.selectBookmarks( bookmarks );
 			}
 		};
Index: CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/tabletools/plugin.js	(revision 5388)
@@ -85,4 +85,41 @@
 
 		return retval;
+	}
+
+	function getFocusedCell( cellsToDelete ) {
+		var i = 0,
+			last = cellsToDelete.length - 1,
+			database = {},
+			cell,focusedCell,
+			tr;
+
+		while ( ( cell = cellsToDelete[ i++ ] ) )
+			CKEDITOR.dom.element.setMarker( database, cell, 'delete_cell', true );
+
+		// 1.first we check left or right side focusable cell row by row;
+		i = 0;
+		while ( ( cell = cellsToDelete[ i++ ] ) )
+		{
+			if ( ( focusedCell = cell.getPrevious() ) && !focusedCell.getCustomData( 'delete_cell' )
+			  || ( focusedCell = cell.getNext()     ) && !focusedCell.getCustomData( 'delete_cell' ) )
+			{
+				CKEDITOR.dom.element.clearAllMarkers( database );
+				return focusedCell;
+			}
+		}
+
+		CKEDITOR.dom.element.clearAllMarkers( database );
+
+		// 2. then we check the toppest row (outside the selection area square) focusable cell
+		tr = cellsToDelete[ 0 ].getParent();
+		if ( ( tr = tr.getPrevious() ) )
+			return tr.getLast();
+
+		// 3. last we check the lowerest  row focusable cell
+		tr = cellsToDelete[ last ].getParent();
+		if ( ( tr = tr.getNext() ) )
+			return tr.getChild( 0 );
+
+		return null;
 	}
 
@@ -278,11 +315,20 @@
 		{
 			var cellsToDelete = getSelectedCells( selectionOrCell );
+			var table = cellsToDelete[ 0 ] && cellsToDelete[ 0 ].getAscendant( 'table' );
+			var cellToFocus   = getFocusedCell( cellsToDelete );
+
 			for ( var i = cellsToDelete.length - 1 ; i >= 0 ; i-- )
 				deleteCells( cellsToDelete[ i ] );
+
+			if ( cellToFocus )
+				placeCursorInCell( cellToFocus, true );
+			else if ( table )
+				table.remove();
 		}
 		else if ( selectionOrCell instanceof CKEDITOR.dom.element )
 		{
-			if ( selectionOrCell.getParent().getChildCount() == 1 )
-				selectionOrCell.getParent().remove();
+			var tr = selectionOrCell.getParent();
+			if ( tr.getChildCount() == 1 )
+				tr.remove();
 			else
 				selectionOrCell.remove();
@@ -681,7 +727,8 @@
 						selection.selectRanges( [ range ] );
 
-						// If the table's parent has only one child, remove it as well.
-						if ( table.getParent().getChildCount() == 1 )
-							table.getParent().remove();
+						// If the table's parent has only one child, remove it,except body,as well.( #5416 )
+						var parent = table.getParent();
+						if ( parent.getChildCount() == 1 && parent.getName() != 'body' )
+							parent.remove();
 						else
 							table.remove();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/toolbar/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/toolbar/plugin.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -414,5 +414,5 @@
  *     '/',
  *     ['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],
- *     ['NumberedList','BulletedList','-','Outdent','Indent','Blockquote'],
+ *     ['NumberedList','BulletedList','-','Outdent','Indent','Blockquote','CreateDiv'],
  *     ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
  *     ['Link','Unlink','Anchor'],
Index: CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/wysiwygarea/plugin.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -171,6 +171,4 @@
 	}
 
-	var isNotWhitespace = CKEDITOR.dom.walker.whitespaces( true );
-
 	/**
 	 *  Auto-fixing block-less content by wrapping paragraph (#3190), prevent
@@ -224,4 +222,9 @@
 				}
 			}
+
+			range.select();
+			// Notify non-IE that selection has changed.
+			if ( !CKEDITOR.env.ie )
+				editor.selectionChange();
 		}
 
@@ -255,7 +258,4 @@
 				paddingBlock.appendBogus();
 		}
-
-		range.select();
-		editor.selectionChange();
 	}
 
@@ -652,4 +652,6 @@
 									if ( !(/<head[\s|>]/).test( data ) )
 										data = data.replace( /<html[^>]*>/, '$&<head><title></title></head>' ) ;
+									else if ( !(/<title[\s|>]/).test( data ) )
+										data = data.replace( /<head[^>]*>/, '$&<title></title>' ) ;
 
 									// The base must be the first tag in the HEAD, e.g. to get relative
Index: CKEditor/branches/versions/3.3.x/_source/themes/default/theme.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/themes/default/theme.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/themes/default/theme.js	(revision 5388)
@@ -284,14 +284,5 @@
 		outer = resizeInner ? container.getChild( 1 ) : container;
 
-	// Resize the width first.
-	// WEBKIT BUG: Webkit requires that we put the editor off from display when we
-	// resize it. If we don't, the browser crashes!
-	CKEDITOR.env.webkit && outer.setStyle( 'display', 'none' );
 	outer.setStyle( 'width', width );
-	if ( CKEDITOR.env.webkit )
-	{
-		outer.$.offsetWidth;
-		outer.setStyle( 'display', '' );
-	}
 
 	// Get the height delta between the outer table and the content area.
